#include "CustomSortFilterSystemModel.h"

#include <QFileSystemModel>
#include <QDebug>



CustomSortFilterProxyModel::CustomSortFilterProxyModel(QObject *parent)
    : QSortFilterProxyModel(parent)
{

}

bool CustomSortFilterProxyModel::filterAcceptsRow(int sourceRow, const QModelIndex &sourceParent) const
{
    if (!sourceParent.isValid())    // only root folders (drives)
    {
        QModelIndex index0 = sourceModel()->index(sourceRow, 0, sourceParent);
        QString driveName = sourceModel()->data(index0).toString();
        if (driveName.contains(filterRegExp()))
        {
            return false;
        }
    }

    return true;
}

QString CustomSortFilterProxyModel::filePath(const QModelIndex &index)
{
    qDebug() << "index.isValid=" << index.isValid()<<index;
    QModelIndex srcIndex = mapToSource(index);
    qDebug()<< "Mapped Index"<< srcIndex;
    QFileSystemModel* srcModel = static_cast<QFileSystemModel*>(sourceModel());
    return srcModel->filePath(srcIndex);
}
