#include <QApplication >
#include <QQmlApplicationEngine>
#include <QDir>
#include <QFileSystemModel>
#include <QQmlContext>

#include "CustomSortFilterSystemModel.h"

int main(int argc, char *argv[])
{
    if (qEnvironmentVariableIsEmpty("QTGLESSTREAM_DISPLAY")) {
        qputenv("QT_QPA_EGLFS_PHYSICAL_WIDTH", QByteArray("213"));
        qputenv("QT_QPA_EGLFS_PHYSICAL_HEIGHT", QByteArray("120"));

        QApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    }

    QApplication  app(argc, argv);

    QQmlApplicationEngine engine;


    // Option #1
    QFileSystemModel *fileSystemModel= new QFileSystemModel();
    CustomSortFilterProxyModel *proxy= new CustomSortFilterProxyModel();
    proxy->setSourceModel(fileSystemModel);
   proxy->setFilterRegExp("*");
    fileSystemModel->setRootPath(QString());
    fileSystemModel->setResolveSymlinks(true);
    fileSystemModel->setFilter(QDir::NoDotAndDotDot | QDir::AllDirs);
    engine.rootContext()->setContextProperty("fileSystemModel", proxy);


    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}
